<div align="center">
  <img width="40%" src="docs/_static/dragonos-logo.svg" alt="dragonos-logo"></br>
  <h2>Lightweight Cloud-Native Kernel</h2>
<a href="https://dragonos.org"><img alt="官网" src="https://img.shields.io/badge/%E5%AE%98%E7%BD%91-DragonOS.org-4c69e4?link=https%3A%2F%2Fbbs.dragonos.org.cn" ></a>
<a href="https://bbs.dragonos.org.cn"><img alt="bbs" src="https://img.shields.io/badge/BBS-bbs.dragonos.org.cn-purple?link=https%3A%2F%2Fbbs.dragonos.org.cn" ></a>

--- 

</div>

# DragonOS

**Languages** [中文](README_CN.md)|English
&nbsp;

&emsp;&emsp;DragonOS is a 64-bit operating system with a completely independent kernel, designed for lightweight cloud computing scenarios, offering Linux binary compatibility. It aims to provide lightweight, high-performance solutions for containerized workloads. Developed using Rust for enhanced reliability.

&emsp;&emsp;The DragonOS open-source community was established in July 2022 and is entirely commercially neutral. We warmly welcome interested developers and enthusiasts to join us!

&emsp;&emsp;DragonOS features excellent and comprehensive architectural design. Compared to other systems of similar scale, DragonOS supports eBPF and virtualization. Currently, we are actively advancing container support, cloud platform compatibility, RISC-V support, as well as porting compilers and application software. Our goal is to achieve large-scale production environment deployment within five years.

&emsp;&emsp;DragonOS is rapidly evolving under community-driven development. Currently, DragonOS has implemented approximately 1/4 of Linux interfaces. In the future, we will provide 100% Linux compatibility along with new features.

## How to Run?

&emsp;&emsp;Running DragonOS is straightforward. You can refer to the following resources to get DragonOS up and running in as little as 15 minutes!

- [Building DragonOS — DragonOS dev documentation](https://docs.dragonos.org.cn/locales/en/introduction/build_system.html)

## Want to Contribute?

Read the [DragonOS Community Introduction Document] carefully to understand how the community operates and how you can contribute!

&emsp;&emsp;If you'd like to join us, check out the issues and participate in discussions or share your ideas. You can also visit the DragonOS forum to stay updated on development progress and tasks: [https://bbs.dragonos.org.cn](https://bbs.dragonos.org.cn)

&emsp;&emsp;You can also bring your creativity and ideas to discuss with the community and contribute new features to DragonOS.

## Sites

- Official Website: **[DragonOS.org](https://dragonos.org)**
- Documentation: **[docs.dragonos.org](https://docs.dragonos.org)**
- Community Introduction: **[community.dragonos.org](https://community.dragonos.org)**
- QQ Group: 476358494

## How to Connect with the Community?

Please read the [Contributor Guide](https://community.dragonos.org/contributors/#%E7%A4%BE%E5%8C%BA)~

- You can find contact details for members of various committees in the [Community Management Team] section.
- You can also locate the contact information for leaders of specific community groups via the [SIGs] and [WGs] pages.

## Contributor List
[Contributors to DragonOS-Community/DragonOS · GitHub](https://github.com/DragonOS-Community/DragonOS/graphs/contributors)

## Sponsorship
[![Sponsor this project](https://img.shields.io/badge/Sponsor_This_Project-DragonOS_Community-ff69b4?style=for-the-badge)](https://dragonos.org/?page_id=37)

&emsp;&emsp;DragonOS is a non-profit open-source project, and its development relies on financial support. All sponsors will be publicly acknowledged. Every contribution you make will help advance DragonOS!

### Where Will Sponsorship Funds Be Used?

We guarantee that all sponsorship funds and items will be used for:

- Event organization, cloud service expenses, and any other purposes beneficial to the development and growth of the DragonOS community.

## 🌟 Sponsor List
**Special thanks to these generous financial supporters** (in reverse chronological order):

- **[中国雅云](https://yacloud.net)** 雅安大数据产业园 - 🥇 Long-term supporter

### Individual Sponsors List
See [Supporters.md](./SUPPORTERS.md)

## Open Source License Notice

This project is open-sourced under the GPLv2 license. You are welcome to use the code in compliance with the open-source license!

If you encounter any violations of the open-source license, we encourage you to email pmc@dragonos.org to report them. Let's work together to build a trustworthy open-source community.

---
## 👩💻 Contributors

> *"Open source shines because of you!"* ✨

**Thanks to all developers who submitted code, fixed issues, or reviewed PRs**:

<a href="https://github.com/DragonOS-Community/dragonos/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=dragonos-community/dragonos" />
</a>

[DragonOS Community Introduction Document]: https://community.dragonos.org/
[Community Management Team]: https://community.dragonos.org/governance/staff-info.html
[SIGs]: https://community.dragonos.org/sigs/
[WGs]: https://community.dragonos.org/wgs/
